      program mkdata6
c
c   ===================================================
c      prepare data for 3D dynamic fault models
c   ===================================================
c
      parameter(mx=512, my=512)
      dimension field(mx,my)
      character*20 namfile
c
c  read size of grid
c
      open(12,file="mkdata.out")
      read(5,*) nx,ny
      write(12,*) 'nx, ny = ',nx,ny
      do i=1,nx
         do j=1,ny
            field(i,j)=0.
         enddo
      enddo
c
c  read external size of fault. This is the maximum size of the fault. 
c  the field will be zero outside the rectangle [ix0, ix1, iy0, iy1]
c  if you do not want this fault, just put ix0=1, ix1=nx, iy0=1, iy1=ny 
c
      read(5,*) ix0, ix1, iy0, iy1
      
      write(12,*) 'size = ',ix0, ix1, iy0, iy1
c
c  read number of asperities inside the fault 
c
      read(5,*) nbsources
      write(12,*) 'nbsources = ',nbsources

c
c  for each source read its type, ets
c  the types of crack available eare
c     1   rectangular patch of size [x0 x1 y0 y1] strin strout 
c     2   circular asperity [x0 y0 radius strin strout] 
c     3   circular anticrack asperity [x0 y0 radius strin strout] 
c     4   circular crack slip [x0 y0 radius strin ] 
c                i.e. strin*sqrt(radius**2-r**2)
c   in all cases strin means stress inside the asperity
c                strout meams stress  outside it
c     5   read field and add what you want
c     6   elliptical asperity [x0 y0 a b strin strout] 
c
c   BOUCLE SUR LES ASPERITES
c
      do nsourc=1,nbsources
         read(5,*) itype
         write(12,*) 'itype  ',itype
         if(itype.eq.1) then
            read(5,*) x0, x1, y0, y1, strin, strout
            write(12,*) "read data =",x0, x1, y0, y1, strin, strout
         elseif(itype.eq.5)then
            read(5,*)namfile
            write(12,*)'leyo file name =',namfile
            open(25,file=namfile)
            read(25,*)nnx,nny
            write(12,*)'nx, nnx =',nx,nnx
            write(12,*)'ny, nny =',ny,nny
         elseif(itype.eq.6)then
            read(5,*) x0, y0, a,b, phi, strin, strout
            write(12,*)'data =', x0, y0, a, b,phi, strin, strout

         else
            read(5,*) x0, y0, radius, strin, strout
            write(12,*)'data =', x0, y0, radius, strin, strout
         endif
         strcen=0.5
         nxyt = nx*ny*nt
         
         do i = ix0,ix1
            do j = iy0,iy1
               if(itype.eq.1) then
                  if((i.ge.x0.and.i.le.x1).and.
     $                 (j.ge.y0.and.j.le.y1)) then
                     field(i,j) = field(i,j)+strin
                  else
                     field(i,j) = field(i,j)+strout
                  endif
               else if(itype.eq.2) then
                  rr=sqrt((i-x0)**2+(j-y0)**2)
                  if(rr.lt.radius)then
                     field(i,j) = field(i,j)+strin
                  else
                     field(i,j) = field(i,j)+strout
                  endif
               else if(itype.eq.3) then
                  rr=sqrt((i-x0)**2+(j-y0)**2)
                  relr=rr/radius
                  field(i,j) = field(i,j)+(strin-strcen*(1-relr**2))
                  if(rr.gt.radius)then
                     field(i,j) = field(i,j)+
     $                    (field(i,j)-strout)*exp((1-relr**2))
     $                    +strout
                  endif
               else if(itype.eq.4) then
                  rr=sqrt((i-x0)**2+(j-y0)**2)
                  relr=rr/radius
                  field(i,j) = field(i,j)+strout
                  if(relr.le.1.)then
                     field(i,j) = field(i,j)+
     $                    strin*sqrt(1-relr**2)
                  endif
               else if(itype.eq.5) then
                  read(25,*)stress
                  field(j,i)=field(j,i)+stress
               else if(itype.eq.6) then
                  x=(i-x0)*cos(phi)+(j-y0)*sin(phi)
                  y=(i-x0)*sin(phi)-(j-y0)*cos(phi)
                  rr=(x/a)**2+(y/b)**2
                  rr=sqrt(rr)
                  if(rr.lt.1.)then
                     field(i,j) = field(i,j)+strin
                  else
                     field(i,j) = field(i,j)+strout
                  endif
               endif
 1          enddo
         enddo
      enddo    
      write(6,*) nx,ny
      do j=1,ny
         write(6,*) (field(i,j),i=1,nx)
      enddo
         write(12,*) 'escribio field ';
      end


